package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        return size()==0;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        Cart cart = null;
        for(int i=0; i<entries.size(); i++){
        if(entries.get(i).getKey().equals(key)){
            cart = entries.get(i).getValue();
        }
        }

        return cart;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        Entry entry= new Entry(key, value);
        remove(key);
        this.entries.add(entry);
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> keys = new ArrayList<>();
        for (Entry entry : entries) {
            keys.add(entry.getKey());
        }

        return keys;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> values = new ArrayList<>();
        for (Entry entry : this.entries) {
            values.add(entry.getValue());
        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        Cart cart = get(key);

        for(int i=0; i<entries.size(); i++){
            if(entries.get(i).getKey().equals(key)){
                entries.remove(i);
            }
        }

        return cart;
    }
}
