package org.zipcoder.store;

import java.util.Objects;

public class User {

    private long id;
    private String name;

    public User(){}

    public User(long id) {
        this.id = id;
    }

    public User(String name) {
        this.name = name;
    }

    public User(long id, String name){
        this.id = id;
        this.name = name;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    public boolean equals(Object obj) {
        boolean same = false;
        User user = (User) obj;
        if(user.getName()== null){
            if(user.getId() == this.id){
                same = true;
            }
        }else if((user.getId() == this.id) && (user.getName().equalsIgnoreCase(this.name))){
            same = true;
        }
        return same;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name);
    }
}
